Package com.netrics.likeit

## Interface NetricsBaseRecSrc

- All Known Subinterfaces:
    `NetricsCompoundRecSrc`, `NetricsRecSrc`
  All Known Implementing Classes:
    `NetricsArrayRecSrc`, `NetricsCompoundReader`, `NetricsCSVRecSrc`, `NetricsTableCursorCompoundRecSrc`, `NetricsTableCursorRecSrc`

      public interface NetricsBaseRecSrc

  Generic interface for reading records.

  This interface defines how sets of records are passed in the API. When a constructor or method needs a set of records it expects an object that implements this interface. By creating a class that implements this interface the user can feed records from any source directly into the API. The API can then stream these records into the engine.

  Records can be single table records, or compound records consisting of a parent record and one or more child records. This base base implementation represents a source that can stream either type of record. This is appropriate for generic applications, such as the deduplication package, that may be handling either type of record. Most of the API methods require one or the other record type. They use extensions of this interface that limit the record type.

  See Also:
    `NetricsRecSrc`, `NetricsCompoundRecSrc`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `NetricsBaseRecord` | `getNext()` | Returns the next record.
    `boolean` | `hasNext()` | True if getNext will return a record.
    `void` | `reset()` | Restarts the sequence of records from the beginning.

- - ### Method Detail

    - #### hasNext

          boolean hasNext()
                   throws NetricsRecSrcException

      True if getNext will return a record.
      Returns:
        True if there is another record, false otherwise
      Throws:
        `NetricsRecSrcException` - if an error occurs.

    - #### getNext

          NetricsBaseRecord getNext()
                             throws NetricsRecSrcException

      Returns the next record.
      Returns:
        the next record
      Throws:
        `NetricsRecSrcException` - if an error occurs, or if there are no more records.

    - #### reset

          void reset()
              throws NetricsRecSrcException

      Restarts the sequence of records from the beginning. Not all record sources may support this operation.
      Throws:
        `NetricsRecSrcException` - if an error occurs, or if the record source does not support resetting.